<script lang="ts">
    import { metatags, goto } from '@roxi/routify';
    import axios from 'axios';
    import { PublicKey } from '../classes/storage/public-key';
    import { IWalletRequestElements, Utils } from '../classes/utils';
    import { Toast } from '../classes/toast';
    metatags.title = 'Get SXP from someone';
    metatags.description = 'Description coming soon...';

    if (!PublicKey.get()) {
        $goto('/settings');
    }

    let loading: boolean = false;

    function popMe() {
        loading = true;
        navigator.geolocation.getCurrentPosition((position: Position) => {
            let lat: number = position.coords.latitude;
            let lon: number = position.coords.longitude;

            Utils.getWalletRequestElements()
                .then((elements: IWalletRequestElements) => {
                    return axios.post('/api/pop-me', {lat, lon, pk: elements.pk, qs: elements.qs, signature: elements.signature})
                        .then(xhr => {
                            Toast.success('Other devices were notified of your presence');
                        })
                        .catch(err => {
                            Toast.failure('Could not notify your presence on other devices');
                        })
                        .finally(() => {
                            loading = false;
                        });
                });
        }, (error: PositionError) => {
            loading = false;
            Toast.failure('Could not retrieve your GPS coordinates: ' + error.message);
        }, {timeout: 8000});
    }
</script>

<h1 class="title has-text-centered">Get SXP from someone</h1>
<div class="is-justify-content-center is-flex">
    <form on:submit|preventDefault={() => popMe()}>
        <div class="card">
            <div class="card-header">
                <div class="card-header-title">
                    Notify people around you
                </div>
            </div>
            <div class="card-content">
                <div class="is-justify-content-center is-flex">
                    <button class="button is-primary" class:is-loading={loading}>Notify</button>
                </div>
            </div>
        </div>
    </form>
</div>
